/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.104 Revision 1.401
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.104 2004/09/17 21:19:49 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.401 2012/08/20 19:45:57 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds
9# @DESCRIPTION:
10# The eutils eclass contains a suite of functions that complement
11# the ones that ebuild.sh already contain. The idea is that the functions
12# are not required in all ebuilds but enough utilize them to have a common
13# home rather than having multiple ebuilds implementing the same thing.
14#
15# Due to the nature of this eclass, some functions may have maintainers
16# different from the overall eclass!
14 17
15DEPEND="!bootstrap? ( sys-devel/patch )" 18if [[ ${___ECLASS_ONCE_EUTILS} != "recur -_+^+_- spank" ]] ; then
19___ECLASS_ONCE_EUTILS="recur -_+^+_- spank"
20
21inherit multilib toolchain-funcs user
16 22
17DESCRIPTION="Based on the ${ECLASS} eclass" 23DESCRIPTION="Based on the ${ECLASS} eclass"
18 24
19# Wait for the supplied number of seconds. If no argument is supplied, defaults 25if has "${EAPI:-0}" 0 1 2; then
20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 26
21# outputting to a terminal, don't wait. For compatability purposes, the argument 27# @FUNCTION: epause
22# must be an integer greater than zero. 28# @USAGE: [seconds]
23# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 29# @DESCRIPTION:
30# Sleep for the specified number of seconds (default of 5 seconds). Useful when
31# printing a message the user should probably be reading and often used in
32# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
33# don't wait at all. Defined in EAPIs 0 1 and 2.
24epause() { 34epause() {
25 if [ -z "$EPAUSE_IGNORE" ] && [ -t 1 ] ; then 35 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
26 sleep ${1:-5}
27 fi
28} 36}
29 37
30# Beep the specified number of times (defaults to five). If our output 38# @FUNCTION: ebeep
31# is not a terminal, don't beep. If the EBEEP_IGNORE env var is set, 39# @USAGE: [number of beeps]
32# don't beep. 40# @DESCRIPTION:
33# Bug 62950, Ciaran McCreesh <ciaranm@gentoo.org> (05 Sep 2004) 41# Issue the specified number of beeps (default of 5 beeps). Useful when
42# printing a message the user should probably be reading and often used in
43# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
44# don't beep at all. Defined in EAPIs 0 1 and 2.
34ebeep() { 45ebeep() {
35 local n 46 local n
36 if [ -z "$EBEEP_IGNORE" ] && [ -t 1 ] ; then 47 if [[ -z ${EBEEP_IGNORE} ]] ; then
37 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 48 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
38 echo -ne "\a" 49 echo -ne "\a"
39 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null 50 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
40 echo -ne "\a" 51 echo -ne "\a"
41 sleep 1 52 sleep 1
42 done 53 done
43 fi 54 fi
44} 55}
45 56
46# This function simply returns the desired lib directory. With portage 57else
47# 2.0.51, we now have support for installing libraries to lib32/lib64 58
48# to accomidate the needs of multilib systems. It's no longer a good idea 59ebeep() {
49# to assume all libraries will end up in lib. Replace any (sane) instances 60 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
50# where lib is named directly with $(get_libdir) if possible. 61}
62
63epause() {
64 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
65}
66
67fi
68
69# @FUNCTION: eqawarn
70# @USAGE: [message]
71# @DESCRIPTION:
72# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
73# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
74# profile.
75if ! declare -F eqawarn >/dev/null ; then
76 eqawarn() {
77 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
78 :
79 }
80fi
81
82# @FUNCTION: ecvs_clean
83# @USAGE: [list of dirs]
84# @DESCRIPTION:
85# Remove CVS directories recursiveley. Useful when a source tarball contains
86# internal CVS directories. Defaults to $PWD.
87ecvs_clean() {
88 [[ -z $* ]] && set -- .
89 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
90 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
91}
92
93# @FUNCTION: esvn_clean
94# @USAGE: [list of dirs]
95# @DESCRIPTION:
96# Remove .svn directories recursiveley. Useful when a source tarball contains
97# internal Subversion directories. Defaults to $PWD.
98esvn_clean() {
99 [[ -z $* ]] && set -- .
100 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
101}
102
103# @FUNCTION: estack_push
104# @USAGE: <stack> [items to push]
105# @DESCRIPTION:
106# Push any number of items onto the specified stack. Pick a name that
107# is a valid variable (i.e. stick to alphanumerics), and push as many
108# items as you like onto the stack at once.
51# 109#
52# Travis Tilley <lv@gentoo.org> (24 Aug 2004) 110# The following code snippet will echo 5, then 4, then 3, then ...
53get_libdir() { 111# @CODE
54 LIBDIR_TEST=$(type econf) 112# estack_push mystack 1 2 3 4 5
55 if [ ! -z "${CONF_LIBDIR_OVERRIDE}" ] ; then 113# while estack_pop mystack i ; do
56 # if there is an override, we want to use that... always. 114# echo "${i}"
57 CONF_LIBDIR="${CONF_LIBDIR_OVERRIDE}" 115# done
58 # We don't need to know the verison of portage. We only need to know 116# @CODE
59 # if there is support for CONF_LIBDIR in econf and co. 117estack_push() {
60 # Danny van Dyk <kugelfang@gentoo.org> 2004/17/09 118 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
61 #elif portageq has_version / '<sys-apps/portage-2.0.51_pre20' ; then 119 local stack_name="__ESTACK_$1__" ; shift
62 # # and if there isnt an override, and we're using a version of 120 eval ${stack_name}+=\( \"\$@\" \)
63 # # portage without CONF_LIBDIR support, force the use of lib. dolib 121}
64 # # and friends from portage 2.0.50 wont be too happy otherwise. 122
65 # CONF_LIBDIR="lib" 123# @FUNCTION: estack_pop
124# @USAGE: <stack> [variable]
125# @DESCRIPTION:
126# Pop a single item off the specified stack. If a variable is specified,
127# the popped item is stored there. If no more items are available, return
128# 1, else return 0. See estack_push for more info.
129estack_pop() {
130 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
131
132 # We use the fugly __estack_xxx var names to avoid collision with
133 # passing back the return value. If we used "local i" and the
134 # caller ran `estack_pop ... i`, we'd end up setting the local
135 # copy of "i" rather than the caller's copy. The __estack_xxx
136 # garbage is preferable to using $1/$2 everywhere as that is a
137 # bit harder to read.
138 local __estack_name="__ESTACK_$1__" ; shift
139 local __estack_retvar=$1 ; shift
140 eval local __estack_i=\${#${__estack_name}\[@\]}
141 # Don't warn -- let the caller interpret this as a failure
142 # or as normal behavior (akin to `shift`)
143 [[ $(( --__estack_i )) -eq -1 ]] && return 1
144
145 if [[ -n ${__estack_retvar} ]] ; then
146 eval ${__estack_retvar}=\"\${${__estack_name}\[${__estack_i}\]}\"
66 #fi 147 fi
67 elif [ "${LIBDIR_TEST/CONF_LIBDIR}" == "${LIBDIR_TEST}" ]; then # we don't have CONF_LIBDIR support 148 eval unset ${__estack_name}\[${__estack_i}\]
68 # will be <portage-2.0.51_pre20
69 CONF_LIBDIR="lib"
70 fi
71 # and of course, default to lib if CONF_LIBDIR isnt set
72 echo ${CONF_LIBDIR:=lib}
73 unset LIBDIR_TEST
74} 149}
75 150
76 151# @FUNCTION: eshopts_push
77get_multilibdir() { 152# @USAGE: [options to `set` or `shopt`]
78 echo ${CONF_MULTILIBDIR:=lib32} 153# @DESCRIPTION:
79} 154# Often times code will want to enable a shell option to change code behavior.
80 155# Since changing shell options can easily break other pieces of code (which
81 156# assume the default state), eshopts_push is used to (1) push the current shell
82# Sometimes you need to override the value returned by get_libdir. A good 157# options onto a stack and (2) pass the specified arguments to set.
83# example of this is xorg-x11, where lib32 isnt a supported configuration,
84# and where lib64 -must- be used on amd64 (for applications that need lib
85# to be 32bit, such as adobe acrobat). Note that this override also bypasses
86# portage version sanity checking.
87# get_libdir_override expects one argument, the result get_libdir should
88# return:
89# 158#
90# get_libdir_override lib64 159# If the first argument is '-s' or '-u', we assume you want to call `shopt`
160# rather than `set` as there are some options only available via that.
91# 161#
92# Travis Tilley <lv@gentoo.org> (31 Aug 2004) 162# A common example is to disable shell globbing so that special meaning/care
93get_libdir_override() { 163# may be used with variables/arguments to custom functions. That would be:
94 CONF_LIBDIR="$1" 164# @CODE
95 CONF_LIBDIR_OVERRIDE="$1" 165# eshopts_push -s noglob
96} 166# for x in ${foo} ; do
97 167# if ...some check... ; then
98# This function generate linker scripts in /usr/lib for dynamic 168# eshopts_pop
99# libs in /lib. This is to fix linking problems when you have
100# the .so in /lib, and the .a in /usr/lib. What happens is that
101# in some cases when linking dynamic, the .a in /usr/lib is used
102# instead of the .so in /lib due to gcc/libtool tweaking ld's
103# library search path. This cause many builds to fail.
104# See bug #4411 for more info.
105#
106# To use, simply call:
107#
108# gen_usr_ldscript libfoo.so
109#
110# Note that you should in general use the unversioned name of
111# the library, as ldconfig should usually update it correctly
112# to point to the latest version of the library present.
113#
114# <azarah@gentoo.org> (26 Oct 2002)
115#
116gen_usr_ldscript() {
117 # Just make sure it exists
118 dodir /usr/$(get_libdir)
119
120 cat > ${D}/usr/$(get_libdir)/$1 <<"END_LDSCRIPT"
121/* GNU ld script
122 Because Gentoo have critical dynamic libraries
123 in /lib, and the static versions in /usr/lib, we
124 need to have a "fake" dynamic lib in /usr/lib,
125 otherwise we run into linking problems.
126 See bug #4411 on http://bugs.gentoo.org/ for
127 more info. */
128END_LDSCRIPT
129
130 echo "GROUP ( /$(get_libdir)/libxxx )" >> ${D}/usr/$(get_libdir)/$1
131 dosed "s:libxxx:$1:" /usr/$(get_libdir)/$1
132
133 return 0
134}
135
136# Simple function to draw a line consisting of '=' the same length as $*
137#
138# <azarah@gentoo.org> (11 Nov 2002)
139#
140draw_line() {
141 local i=0
142 local str_length=""
143
144 # Handle calls that do not have args, or wc not being installed ...
145 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
146 then
147 echo "==============================================================="
148 return 0 169# return 0
149 fi 170# fi
150
151 # Get the length of $*
152 str_length="$(echo -n "$*" | wc -m)"
153
154 while [ "$i" -lt "${str_length}" ]
155 do
156 echo -n "="
157
158 i=$((i + 1))
159 done 171# done
160 172# eshopts_pop
161 echo 173# @CODE
162 174eshopts_push() {
163 return 0 175 if [[ $1 == -[su] ]] ; then
176 estack_push eshopts "$(shopt -p)"
177 [[ $# -eq 0 ]] && return 0
178 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
179 else
180 estack_push eshopts $-
181 [[ $# -eq 0 ]] && return 0
182 set "$@" || die "${FUNCNAME}: bad options to set: $*"
183 fi
164} 184}
165 185
166# Default directory where patches are located 186# @FUNCTION: eshopts_pop
187# @USAGE:
188# @DESCRIPTION:
189# Restore the shell options to the state saved with the corresponding
190# eshopts_push call. See that function for more details.
191eshopts_pop() {
192 local s
193 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
194 if [[ ${s} == "shopt -"* ]] ; then
195 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
196 else
197 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
198 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
199 fi
200}
201
202# @FUNCTION: eumask_push
203# @USAGE: <new umask>
204# @DESCRIPTION:
205# Set the umask to the new value specified while saving the previous
206# value onto a stack. Useful for temporarily changing the umask.
207eumask_push() {
208 estack_push eumask "$(umask)"
209 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
210}
211
212# @FUNCTION: eumask_pop
213# @USAGE:
214# @DESCRIPTION:
215# Restore the previous umask state.
216eumask_pop() {
217 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
218 local s
219 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
220 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
221}
222
223# @VARIABLE: EPATCH_SOURCE
224# @DESCRIPTION:
225# Default directory to search for patches.
167EPATCH_SOURCE="${WORKDIR}/patch" 226EPATCH_SOURCE="${WORKDIR}/patch"
168# Default extension for patches 227# @VARIABLE: EPATCH_SUFFIX
228# @DESCRIPTION:
229# Default extension for patches (do not prefix the period yourself).
169EPATCH_SUFFIX="patch.bz2" 230EPATCH_SUFFIX="patch.bz2"
170# Default options for patch 231# @VARIABLE: EPATCH_OPTS
171# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 232# @DESCRIPTION:
233# Options to pass to patch. Meant for ebuild/package-specific tweaking
234# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
235# for single patch tweaking, you can also pass flags directly to epatch.
172EPATCH_OPTS="-g0" 236EPATCH_OPTS=""
237# @VARIABLE: EPATCH_COMMON_OPTS
238# @DESCRIPTION:
239# Common options to pass to `patch`. You probably should never need to
240# change these. If you do, please discuss it with base-system first to
241# be sure.
242# @CODE
243# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
244# --no-backup-if-mismatch - do not leave .orig files behind
245# -E - automatically remove empty files
246# @CODE
247EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
248# @VARIABLE: EPATCH_EXCLUDE
249# @DESCRIPTION:
173# List of patches not to apply. Not this is only file names, 250# List of patches not to apply. Note this is only file names,
174# and not the full path .. 251# and not the full path. Globs accepted.
175EPATCH_EXCLUDE="" 252EPATCH_EXCLUDE=""
253# @VARIABLE: EPATCH_SINGLE_MSG
254# @DESCRIPTION:
176# Change the printed message for a single patch. 255# Change the printed message for a single patch.
177EPATCH_SINGLE_MSG="" 256EPATCH_SINGLE_MSG=""
178# Force applying bulk patches even if not following the style: 257# @VARIABLE: EPATCH_MULTI_MSG
179# 258# @DESCRIPTION:
180# ??_${ARCH}_foo.${EPATCH_SUFFIX} 259# Change the printed message for multiple patches.
181# 260EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
261# @VARIABLE: EPATCH_FORCE
262# @DESCRIPTION:
263# Only require patches to match EPATCH_SUFFIX rather than the extended
264# arch naming style.
182EPATCH_FORCE="no" 265EPATCH_FORCE="no"
183 266
184# This function is for bulk patching, or in theory for just one 267# @FUNCTION: epatch
185# or two patches. 268# @USAGE: [options] [patches] [dirs of patches]
269# @DESCRIPTION:
270# epatch is designed to greatly simplify the application of patches. It can
271# process patch files directly, or directories of patches. The patches may be
272# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
273# the -p option as epatch will automatically attempt -p0 to -p5 until things
274# apply successfully.
186# 275#
187# It should work with .bz2, .gz, .zip and plain text patches. 276# If you do not specify any patches/dirs, then epatch will default to the
188# Currently all patches should be the same format. 277# directory specified by EPATCH_SOURCE.
189# 278#
190# You do not have to specify '-p' option to patch, as it will 279# Any options specified that start with a dash will be passed down to patch
191# try with -p0 to -p5 until it succeed, or fail at -p5. 280# for this specific invocation. As soon as an arg w/out a dash is found, then
281# arg processing stops.
192# 282#
193# Above EPATCH_* variables can be used to control various defaults, 283# When processing directories, epatch will apply all patches that match:
194# bug they should be left as is to ensure an ebuild can rely on 284# @CODE
195# them for. 285# if ${EPATCH_FORCE} != "yes"
196#
197# Patches are applied in current directory.
198#
199# Bulk Patches should preferibly have the form of:
200#
201# ??_${ARCH}_foo.${EPATCH_SUFFIX} 286# ??_${ARCH}_foo.${EPATCH_SUFFIX}
287# else
288# *.${EPATCH_SUFFIX}
289# @CODE
290# The leading ?? are typically numbers used to force consistent patch ordering.
291# The arch field is used to apply patches only for the host architecture with
292# the special value of "all" means apply for everyone. Note that using values
293# other than "all" is highly discouraged -- you should apply patches all the
294# time and let architecture details be detected at configure/compile time.
202# 295#
203# For example: 296# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
297# for patches to apply.
204# 298#
205# 01_all_misc-fix.patch.bz2 299# Refer to the other EPATCH_xxx variables for more customization of behavior.
206# 02_sparc_another-fix.patch.bz2
207#
208# This ensures that there are a set order, and you can have ARCH
209# specific patches.
210#
211# If you however give an argument to epatch(), it will treat it as a
212# single patch that need to be applied if its a file. If on the other
213# hand its a directory, it will set EPATCH_SOURCE to this.
214#
215# <azarah@gentoo.org> (10 Nov 2002)
216#
217epatch() { 300epatch() {
218 local PIPE_CMD="" 301 _epatch_draw_line() {
219 local STDERR_TARGET="${T}/$$.out" 302 # create a line of same length as input string
220 local PATCH_TARGET="${T}/$$.patch" 303 [[ -z $1 ]] && set "$(printf "%65s" '')"
221 local PATCH_SUFFIX="" 304 echo "${1//?/=}"
222 local SINGLE_PATCH="no" 305 }
223 local x=""
224 306
225 if [ "$#" -gt 1 ] 307 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
226 then 308
309 # First process options. We localize the EPATCH_OPTS setting
310 # from above so that we can pass it on in the loop below with
311 # any additional values the user has specified.
312 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
313 while [[ $# -gt 0 ]] ; do
314 case $1 in
315 -*) EPATCH_OPTS+=( "$1" ) ;;
316 *) break ;;
317 esac
318 shift
319 done
320
321 # Let the rest of the code process one user arg at a time --
322 # each arg may expand into multiple patches, and each arg may
323 # need to start off with the default global EPATCH_xxx values
324 if [[ $# -gt 1 ]] ; then
227 local m="" 325 local m
228 einfo "${#} patches to apply..."
229 for m in "$@" ; do 326 for m in "$@" ; do
230 epatch "${m}" 327 epatch "${m}"
231 done 328 done
232 return 0 329 return 0
233 fi 330 fi
234 331
235 if [ -n "$1" -a -f "$1" ] 332 local SINGLE_PATCH="no"
236 then 333 # no args means process ${EPATCH_SOURCE}
334 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
335
336 if [[ -f $1 ]] ; then
237 SINGLE_PATCH="yes" 337 SINGLE_PATCH="yes"
238 338 set -- "$1"
239 local EPATCH_SOURCE="$1" 339 # Use the suffix from the single patch (localize it); the code
340 # below will find the suffix for us
240 local EPATCH_SUFFIX="${1##*\.}" 341 local EPATCH_SUFFIX=$1
241 342
242 elif [ -n "$1" -a -d "$1" ] 343 elif [[ -d $1 ]] ; then
243 then 344 # Some people like to make dirs of patches w/out suffixes (vim)
244 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 345 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
245 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 346
347 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
348 # Re-use EPATCH_SOURCE as a search dir
349 epatch "${EPATCH_SOURCE}/$1"
350 return $?
351
352 else
353 # sanity check ... if it isn't a dir or file, wtf man ?
354 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
355 echo
356 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
357 eerror
358 eerror " ${EPATCH_SOURCE}"
359 eerror " ( ${EPATCH_SOURCE##*/} )"
360 echo
361 die "Cannot find \$EPATCH_SOURCE!"
362 fi
363
364 # Now that we know we're actually going to apply something, merge
365 # all of the patch options back in to a single variable for below.
366 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
367
368 local PIPE_CMD
369 case ${EPATCH_SUFFIX##*\.} in
370 xz) PIPE_CMD="xz -dc" ;;
371 lzma) PIPE_CMD="lzma -dc" ;;
372 bz2) PIPE_CMD="bzip2 -dc" ;;
373 gz|Z|z) PIPE_CMD="gzip -dc" ;;
374 ZIP|zip) PIPE_CMD="unzip -p" ;;
375 *) ;;
376 esac
377
378 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
379
380 local x
381 for x in "$@" ; do
382 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
383 # didn't match anything, ignore continue on
384 [[ ! -f ${x} ]] && continue
385
386 local patchname=${x##*/}
387
388 # Apply single patches, or forced sets of patches, or
389 # patches with ARCH dependant names.
390 # ???_arch_foo.patch
391 # Else, skip this input altogether
392 local a=${patchname#*_} # strip the ???_
393 a=${a%%_*} # strip the _foo.patch
394 if ! [[ ${SINGLE_PATCH} == "yes" || \
395 ${EPATCH_FORCE} == "yes" || \
396 ${a} == all || \
397 ${a} == ${ARCH} ]]
246 then 398 then
247 local EPATCH_SOURCE="$1/*" 399 continue
400 fi
401
402 # Let people filter things dynamically
403 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
404 # let people use globs in the exclude
405 eshopts_push -o noglob
406
407 local ex
408 for ex in ${EPATCH_EXCLUDE} ; do
409 if [[ ${patchname} == ${ex} ]] ; then
410 eshopts_pop
411 continue 2
412 fi
413 done
414
415 eshopts_pop
416 fi
417
418 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
419 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
420 einfo "${EPATCH_SINGLE_MSG}"
421 else
422 einfo "Applying ${patchname} ..."
423 fi
248 else 424 else
249 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 425 einfo " ${patchname} ..."
426 fi
427
428 # most of the time, there will only be one run per unique name,
429 # but if there are more, make sure we get unique log filenames
430 local STDERR_TARGET="${T}/${patchname}.out"
431 if [[ -e ${STDERR_TARGET} ]] ; then
432 STDERR_TARGET="${T}/${patchname}-$$.out"
433 fi
434
435 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
436
437 # Decompress the patch if need be
438 local count=0
439 local PATCH_TARGET
440 if [[ -n ${PIPE_CMD} ]] ; then
441 PATCH_TARGET="${T}/$$.patch"
442 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
443
444 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
445 echo
446 eerror "Could not extract patch!"
447 #die "Could not extract patch!"
448 count=5
449 break
250 fi 450 fi
451 else
452 PATCH_TARGET=${x}
453 fi
454
455 # Check for absolute paths in patches. If sandbox is disabled,
456 # people could (accidently) patch files in the root filesystem.
457 # Or trigger other unpleasantries #237667. So disallow -p0 on
458 # such patches.
459 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
460 if [[ -n ${abs_paths} ]] ; then
461 count=1
462 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
463 fi
464 # Similar reason, but with relative paths.
465 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
466 if [[ -n ${rel_paths} ]] ; then
467 eqawarn "QA Notice: Your patch uses relative paths '../'."
468 eqawarn " In the future this will cause a failure."
469 eqawarn "${rel_paths}"
470 fi
471
472 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
473 local patch_cmd
474 while [[ ${count} -lt 5 ]] ; do
475 patch_cmd="${BASH_ALIASES[patch]:-patch} -p${count} ${EPATCH_OPTS}"
476
477 # Generate some useful debug info ...
478 (
479 _epatch_draw_line "***** ${patchname} *****"
480 echo
481 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
482 echo
483 _epatch_draw_line "***** ${patchname} *****"
484 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
485 ret=$?
486 echo
487 echo "patch program exited with status ${ret}"
488 exit ${ret}
489 ) >> "${STDERR_TARGET}"
490
491 if [ $? -eq 0 ] ; then
492 (
493 _epatch_draw_line "***** ${patchname} *****"
494 echo
495 echo "ACTUALLY APPLYING ${patchname} ..."
496 echo
497 _epatch_draw_line "***** ${patchname} *****"
498 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
499 ret=$?
500 echo
501 echo "patch program exited with status ${ret}"
502 exit ${ret}
503 ) >> "${STDERR_TARGET}"
504
505 if [ $? -ne 0 ] ; then
506 echo
507 eerror "A dry-run of patch command succeeded, but actually"
508 eerror "applying the patch failed!"
509 #die "Real world sux compared to the dreamworld!"
510 count=5
511 fi
512 break
513 fi
514
515 : $(( count++ ))
516 done
517
518 # if we had to decompress the patch, delete the temp one
519 if [[ -n ${PIPE_CMD} ]] ; then
520 rm -f "${PATCH_TARGET}"
521 fi
522
523 if [[ ${count} -ge 5 ]] ; then
524 echo
525 eerror "Failed Patch: ${patchname} !"
526 eerror " ( ${PATCH_TARGET} )"
527 eerror
528 eerror "Include in your bugreport the contents of:"
529 eerror
530 eerror " ${STDERR_TARGET}"
531 echo
532 die "Failed Patch: ${patchname}!"
533 fi
534
535 # if everything worked, delete the full debug patch log
536 rm -f "${STDERR_TARGET}"
537
538 # then log away the exact stuff for people to review later
539 cat <<-EOF >> "${T}/epatch.log"
540 PATCH: ${x}
541 CMD: ${patch_cmd}
542 PWD: ${PWD}
543
544 EOF
545 eend 0
546 done
547
548 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
549 : # everything worked
550}
551
552# @FUNCTION: epatch_user
553# @USAGE:
554# @DESCRIPTION:
555# Applies user-provided patches to the source tree. The patches are
556# taken from /etc/portage/patches/<CATEGORY>/<PF|P|PN>/, where the first
557# of these three directories to exist will be the one to use, ignoring
558# any more general directories which might exist as well. They must end
559# in ".patch" to be applied.
560#
561# User patches are intended for quick testing of patches without ebuild
562# modifications, as well as for permanent customizations a user might
563# desire. Obviously, there can be no official support for arbitrarily
564# patched ebuilds. So whenever a build log in a bug report mentions that
565# user patches were applied, the user should be asked to reproduce the
566# problem without these.
567#
568# Not all ebuilds do call this function, so placing patches in the
569# stated directory might or might not work, depending on the package and
570# the eclasses it inherits and uses. It is safe to call the function
571# repeatedly, so it is always possible to add a call at the ebuild
572# level. The first call is the time when the patches will be
573# applied.
574#
575# Ideally, this function should be called after gentoo-specific patches
576# have been applied, so that their code can be modified as well, but
577# before calls to e.g. eautoreconf, as the user patches might affect
578# autotool input files as well.
579epatch_user() {
580 [[ $# -ne 0 ]] && die "epatch_user takes no options"
581
582 # Allow multiple calls to this function; ignore all but the first
583 local applied="${T}/epatch_user.log"
584 [[ -e ${applied} ]] && return 2
585
586 # don't clobber any EPATCH vars that the parent might want
587 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
588 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}; do
589 EPATCH_SOURCE=${base}/${CTARGET}/${check}
590 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
591 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
592 if [[ -d ${EPATCH_SOURCE} ]] ; then
593 EPATCH_SOURCE=${EPATCH_SOURCE} \
594 EPATCH_SUFFIX="patch" \
595 EPATCH_FORCE="yes" \
596 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
597 epatch
598 echo "${EPATCH_SOURCE}" > "${applied}"
599 return 0
600 fi
601 done
602 echo "none" > "${applied}"
603 return 1
604}
605
606# @FUNCTION: emktemp
607# @USAGE: [temp dir]
608# @DESCRIPTION:
609# Cheap replacement for when debianutils (and thus mktemp)
610# does not exist on the users system.
611emktemp() {
612 local exe="touch"
613 [[ $1 == -d ]] && exe="mkdir" && shift
614 local topdir=$1
615
616 if [[ -z ${topdir} ]] ; then
617 [[ -z ${T} ]] \
618 && topdir="/tmp" \
619 || topdir=${T}
620 fi
621
622 if ! type -P mktemp > /dev/null ; then
623 # system lacks `mktemp` so we have to fake it
624 local tmp=/
625 while [[ -e ${tmp} ]] ; do
626 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
627 done
628 ${exe} "${tmp}" || ${exe} -p "${tmp}"
629 echo "${tmp}"
251 else 630 else
252 if [ ! -d ${EPATCH_SOURCE} ] 631 # the args here will give slightly wierd names on BSD,
253 then 632 # but should produce a usable file on all userlands
254 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 633 if [[ ${exe} == "touch" ]] ; then
255 then 634 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
256 EPATCH_SOURCE="$1" 635 else
636 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
637 fi
638 fi
639}
640
641# @FUNCTION: edos2unix
642# @USAGE: <file> [more files ...]
643# @DESCRIPTION:
644# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
645# to remove all of these text utilities from DEPEND variables because this
646# is a script based solution. Just give it a list of files to convert and
647# they will all be changed from the DOS CRLF format to the UNIX LF format.
648edos2unix() {
649 [[ $# -eq 0 ]] && return 0
650 sed -i 's/\r$//' -- "$@" || die
651}
652
653# @FUNCTION: make_desktop_entry
654# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
655# @DESCRIPTION:
656# Make a .desktop file.
657#
658# @CODE
659# binary: what command does the app run with ?
660# name: the name that will show up in the menu
661# icon: the icon to use in the menu entry
662# this can be relative (to /usr/share/pixmaps) or
663# a full path to an icon
664# type: what kind of application is this?
665# for categories:
666# http://standards.freedesktop.org/menu-spec/latest/apa.html
667# if unset, function tries to guess from package's category
668# fields: extra fields to append to the desktop file; a printf string
669# @CODE
670make_desktop_entry() {
671 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
672
673 local exec=${1}
674 local name=${2:-${PN}}
675 local icon=${3:-${PN}}
676 local type=${4}
677 local fields=${5}
678
679 if [[ -z ${type} ]] ; then
680 local catmaj=${CATEGORY%%-*}
681 local catmin=${CATEGORY##*-}
682 case ${catmaj} in
683 app)
684 case ${catmin} in
685 accessibility) type="Utility;Accessibility";;
686 admin) type=System;;
687 antivirus) type=System;;
688 arch) type="Utility;Archiving";;
689 backup) type="Utility;Archiving";;
690 cdr) type="AudioVideo;DiscBurning";;
691 dicts) type="Office;Dictionary";;
692 doc) type=Documentation;;
693 editors) type="Utility;TextEditor";;
694 emacs) type="Development;TextEditor";;
695 emulation) type="System;Emulator";;
696 laptop) type="Settings;HardwareSettings";;
697 office) type=Office;;
698 pda) type="Office;PDA";;
699 vim) type="Development;TextEditor";;
700 xemacs) type="Development;TextEditor";;
701 esac
702 ;;
703
704 dev)
705 type="Development"
706 ;;
707
708 games)
709 case ${catmin} in
710 action|fps) type=ActionGame;;
711 arcade) type=ArcadeGame;;
712 board) type=BoardGame;;
713 emulation) type=Emulator;;
714 kids) type=KidsGame;;
715 puzzle) type=LogicGame;;
716 roguelike) type=RolePlaying;;
717 rpg) type=RolePlaying;;
718 simulation) type=Simulation;;
719 sports) type=SportsGame;;
720 strategy) type=StrategyGame;;
721 esac
722 type="Game;${type}"
723 ;;
724
725 gnome)
726 type="Gnome;GTK"
727 ;;
728
729 kde)
730 type="KDE;Qt"
731 ;;
732
733 mail)
734 type="Network;Email"
735 ;;
736
737 media)
738 case ${catmin} in
739 gfx)
740 type=Graphics
741 ;;
742 *)
743 case ${catmin} in
744 radio) type=Tuner;;
745 sound) type=Audio;;
746 tv) type=TV;;
747 video) type=Video;;
748 esac
749 type="AudioVideo;${type}"
750 ;;
751 esac
752 ;;
753
754 net)
755 case ${catmin} in
756 dialup) type=Dialup;;
757 ftp) type=FileTransfer;;
758 im) type=InstantMessaging;;
759 irc) type=IRCClient;;
760 mail) type=Email;;
761 news) type=News;;
762 nntp) type=News;;
763 p2p) type=FileTransfer;;
764 voip) type=Telephony;;
765 esac
766 type="Network;${type}"
767 ;;
768
769 sci)
770 case ${catmin} in
771 astro*) type=Astronomy;;
772 bio*) type=Biology;;
773 calc*) type=Calculator;;
774 chem*) type=Chemistry;;
775 elec*) type=Electronics;;
776 geo*) type=Geology;;
777 math*) type=Math;;
778 physics) type=Physics;;
779 visual*) type=DataVisualization;;
780 esac
781 type="Education;Science;${type}"
782 ;;
783
784 sys)
785 type="System"
786 ;;
787
788 www)
789 case ${catmin} in
790 client) type=WebBrowser;;
791 esac
792 type="Network;${type}"
793 ;;
794
795 *)
796 type=
797 ;;
798 esac
799 fi
800 if [ "${SLOT}" == "0" ] ; then
801 local desktop_name="${PN}"
802 else
803 local desktop_name="${PN}-${SLOT}"
804 fi
805 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
806 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
807
808 # Don't append another ";" when a valid category value is provided.
809 type=${type%;}${type:+;}
810
811 eshopts_push -s extglob
812 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
813 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
814 ewarn "allowed in .desktop files if the value is not an absolute path."
815 icon=${icon%.@(xpm|png|svg)}
816 fi
817 eshopts_pop
818
819 cat <<-EOF > "${desktop}"
820 [Desktop Entry]
821 Name=${name}
822 Type=Application
823 Comment=${DESCRIPTION}
824 Exec=${exec}
825 TryExec=${exec%% *}
826 Icon=${icon}
827 Categories=${type}
828 EOF
829
830 if [[ ${fields:-=} != *=* ]] ; then
831 # 5th arg used to be value to Path=
832 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
833 fields="Path=${fields}"
834 fi
835 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
836
837 (
838 # wrap the env here so that the 'insinto' call
839 # doesn't corrupt the env of the caller
840 insinto /usr/share/applications
841 doins "${desktop}"
842 ) || die "installing desktop file failed"
843}
844
845# @FUNCTION: validate_desktop_entries
846# @USAGE: [directories]
847# @MAINTAINER:
848# Carsten Lohrke <carlo@gentoo.org>
849# @DESCRIPTION:
850# Validate desktop entries using desktop-file-utils
851validate_desktop_entries() {
852 if [[ -x /usr/bin/desktop-file-validate ]] ; then
853 einfo "Checking desktop entry validity"
854 local directories=""
855 for d in /usr/share/applications $@ ; do
856 [[ -d ${D}${d} ]] && directories="${directories} ${D}${d}"
857 done
858 if [[ -n ${directories} ]] ; then
859 for FILE in $(find ${directories} -name "*\.desktop" \
860 -not -path '*.hidden*' | sort -u 2>/dev/null)
861 do
862 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
863 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
864 [[ -n $temp ]] && elog ${temp/--/${FILE/${D}/}:}
865 done
866 fi
867 echo ""
868 else
869 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
870 fi
871}
872
873# @FUNCTION: make_session_desktop
874# @USAGE: <title> <command> [command args...]
875# @DESCRIPTION:
876# Make a GDM/KDM Session file. The title is the file to execute to start the
877# Window Manager. The command is the name of the Window Manager.
878#
879# You can set the name of the file via the ${wm} variable.
880make_session_desktop() {
881 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
882 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
883
884 local title=$1
885 local command=$2
886 local desktop=${T}/${wm:-${PN}}.desktop
887 shift 2
888
889 cat <<-EOF > "${desktop}"
890 [Desktop Entry]
891 Name=${title}
892 Comment=This session logs you into ${title}
893 Exec=${command} $*
894 TryExec=${command}
895 Type=XSession
896 EOF
897
898 (
899 # wrap the env here so that the 'insinto' call
900 # doesn't corrupt the env of the caller
901 insinto /usr/share/xsessions
902 doins "${desktop}"
903 )
904}
905
906# @FUNCTION: domenu
907# @USAGE: <menus>
908# @DESCRIPTION:
909# Install the list of .desktop menu files into the appropriate directory
910# (/usr/share/applications).
911domenu() {
912 (
913 # wrap the env here so that the 'insinto' call
914 # doesn't corrupt the env of the caller
915 local i j ret=0
916 insinto /usr/share/applications
917 for i in "$@" ; do
918 if [[ -f ${i} ]] ; then
919 doins "${i}"
920 ((ret+=$?))
921 elif [[ -d ${i} ]] ; then
922 for j in "${i}"/*.desktop ; do
923 doins "${j}"
924 ((ret+=$?))
925 done
926 else
927 ((++ret))
928 fi
929 done
930 exit ${ret}
931 )
932}
933
934# @FUNCTION: newmenu
935# @USAGE: <menu> <newname>
936# @DESCRIPTION:
937# Like all other new* functions, install the specified menu as newname.
938newmenu() {
939 (
940 # wrap the env here so that the 'insinto' call
941 # doesn't corrupt the env of the caller
942 insinto /usr/share/applications
943 newins "$@"
944 )
945}
946
947# @FUNCTION: _iconins
948# @INTERNAL
949# @DESCRIPTION:
950# function for use in doicon and newicon
951_iconins() {
952 (
953 # wrap the env here so that the 'insinto' call
954 # doesn't corrupt the env of the caller
955 local funcname=$1; shift
956 local size dir
957 local context=apps
958 local theme=hicolor
959
960 while [[ $# -gt 0 ]] ; do
961 case $1 in
962 -s|--size)
963 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
964 size=${2%%x*}
965 else
966 size=${2}
257 fi 967 fi
258 968 case ${size} in
259 echo 969 16|22|24|32|36|48|64|72|96|128|192|256)
260 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 970 size=${size}x${size};;
261 eerror 971 scalable)
262 eerror " ${EPATCH_SOURCE}"
263 echo
264 die "Cannot find \$EPATCH_SOURCE!"
265 fi
266
267 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
268 fi
269
270 case ${EPATCH_SUFFIX##*\.} in
271 bz2)
272 PIPE_CMD="bzip2 -dc"
273 PATCH_SUFFIX="bz2"
274 ;; 972 ;;
275 gz|Z|z) 973 *)
276 PIPE_CMD="gzip -dc" 974 eerror "${size} is an unsupported icon size!"
277 PATCH_SUFFIX="gz" 975 exit 1;;
278 ;; 976 esac
279 ZIP|zip) 977 shift 2;;
280 PIPE_CMD="unzip -p" 978 -t|--theme)
281 PATCH_SUFFIX="zip" 979 theme=${2}
282 ;; 980 shift 2;;
981 -c|--context)
982 context=${2}
983 shift 2;;
283 *) 984 *)
284 PIPE_CMD="cat" 985 if [[ -z ${size} ]] ; then
285 PATCH_SUFFIX="patch" 986 insinto /usr/share/pixmaps
286 ;; 987 else
287 esac 988 insinto /usr/share/icons/${theme}/${size}/${context}
288
289 if [ "${SINGLE_PATCH}" = "no" ]
290 then
291 einfo "Applying various patches (bugfixes/updates)..."
292 fi
293 for x in ${EPATCH_SOURCE}
294 do
295 # New ARCH dependant patch naming scheme...
296 #
297 # ???_arch_foo.patch
298 #
299 if [ -f ${x} ] && \
300 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
301 [ "${EPATCH_FORCE}" = "yes" ])
302 then
303 local count=0
304 local popts="${EPATCH_OPTS}"
305
306 if [ -n "${EPATCH_EXCLUDE}" ]
307 then
308 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
309 then
310 continue
311 fi
312 fi 989 fi
313 990
314 if [ "${SINGLE_PATCH}" = "yes" ] 991 if [[ ${funcname} == doicon ]] ; then
315 then 992 if [[ -f $1 ]] ; then
316 if [ -n "${EPATCH_SINGLE_MSG}" ] 993 doins "${1}"
317 then 994 elif [[ -d $1 ]] ; then
318 einfo "${EPATCH_SINGLE_MSG}" 995 shopt -s nullglob
996 doins "${1}"/*.{png,svg}
997 shopt -u nullglob
319 else 998 else
320 einfo "Applying ${x##*/}..." 999 eerror "${1} is not a valid file/directory!"
1000 exit 1
321 fi 1001 fi
322 else 1002 else
323 einfo " ${x##*/}..." 1003 break
324 fi 1004 fi
325 1005 shift 1;;
326 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1006 esac
327 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
328
329 # Allow for prefix to differ ... im lazy, so shoot me :/
330 while [ "${count}" -lt 5 ]
331 do
332 # Generate some useful debug info ...
333 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
334 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
335
336 if [ "${PATCH_SUFFIX}" != "patch" ]
337 then
338 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
339 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
340 else
341 PATCH_TARGET="${x}"
342 fi
343
344 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
345 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
346
347 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
348 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
349
350 if [ "${PATCH_SUFFIX}" != "patch" ]
351 then
352 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
353 then
354 echo
355 eerror "Could not extract patch!"
356 #die "Could not extract patch!"
357 count=5
358 break
359 fi
360 fi
361
362 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
363 then
364 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
365 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
366 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
367 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
368 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
369
370 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
371
372 if [ "$?" -ne 0 ]
373 then
374 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
375 echo
376 eerror "A dry-run of patch command succeeded, but actually"
377 eerror "applying the patch failed!"
378 #die "Real world sux compared to the dreamworld!"
379 count=5
380 fi
381
382 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
383
384 break
385 fi
386
387 count=$((count + 1))
388 done
389
390 if [ "${PATCH_SUFFIX}" != "patch" ]
391 then
392 rm -f ${PATCH_TARGET}
393 fi
394
395 if [ "${count}" -eq 5 ]
396 then
397 echo
398 eerror "Failed Patch: ${x##*/}!"
399 eerror
400 eerror "Include in your bugreport the contents of:"
401 eerror
402 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
403 echo
404 die "Failed Patch: ${x##*/}!"
405 fi
406
407 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
408
409 eend 0
410 fi
411 done 1007 done
412 if [ "${SINGLE_PATCH}" = "no" ] 1008 if [[ ${funcname} == newicon ]] ; then
413 then 1009 newins "$@"
414 einfo "Done with patching"
415 fi
416}
417
418# This function return true if we are using the NPTL pthreads
419# implementation.
420#
421# <azarah@gentoo.org> (06 March 2003)
422#
423have_NPTL() {
424 cat > ${T}/test-nptl.c <<-"END"
425 #define _XOPEN_SOURCE
426 #include <unistd.h>
427 #include <stdio.h>
428
429 int main()
430 {
431 char buf[255];
432 char *str = buf;
433
434 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
435 if (NULL != str) {
436 printf("%s\n", str);
437 if (NULL != strstr(str, "NPTL"))
438 return 0;
439 }
440
441 return 1;
442 }
443 END
444
445 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
446 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
447 then
448 echo "yes"
449 einfon "Checking what PTHREADS implementation we have ... "
450 if ${T}/nptl
451 then
452 return 0
453 else
454 return 1
455 fi 1010 fi
456 else 1011 ) || die
457 echo "no"
458 fi
459
460 return 1
461} 1012}
462 1013
463# This function check how many cpu's are present, and then set 1014# @FUNCTION: doicon
464# -j in MAKEOPTS accordingly. 1015# @USAGE: [options] <icons>
1016# @DESCRIPTION:
1017# Install icon into the icon directory /usr/share/icons or into
1018# /usr/share/pixmaps if "--size" is not set.
1019# This is useful in conjunction with creating desktop/menu files.
465# 1020#
466# Thanks to nall <nall@gentoo.org> for this. 1021# @CODE
1022# options:
1023# -s, --size
1024# !!! must specify to install into /usr/share/icons/... !!!
1025# size of the icon, like 48 or 48x48
1026# supported icon sizes are:
1027# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1028# -c, --context
1029# defaults to "apps"
1030# -t, --theme
1031# defaults to "hicolor"
467# 1032#
468get_number_of_jobs() { 1033# icons: list of icons
469 local jobs=0
470
471 if [ ! -r /proc/cpuinfo ]
472 then
473 return 1
474 fi
475
476 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
477 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
478 then
479 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
480 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
481 ADMINPARAM="${ADMINPARAM/-j}"
482 fi
483
484 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
485
486 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
487 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
488 then
489 # these archs will always have "[Pp]rocessor"
490 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
491
492 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
493 then
494 # sparc always has "ncpus active"
495 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
496
497 elif [ "${ARCH}" = "alpha" ]
498 then
499 # alpha has "cpus active", but only when compiled with SMP
500 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
501 then
502 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
503 else
504 jobs=2
505 fi
506
507 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
508 then
509 # ppc has "processor", but only when compiled with SMP
510 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
511 then
512 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
513 else
514 jobs=2
515 fi
516 elif [ "${ARCH}" = "s390" ]
517 then
518 # s390 has "# processors : "
519 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
520 else
521 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
522 die "Unknown ARCH -- ${ARCH}!"
523 fi
524
525 # Make sure the number is valid ...
526 if [ "${jobs}" -lt 1 ]
527 then
528 jobs=1
529 fi
530
531 if [ -n "${ADMINPARAM}" ]
532 then
533 if [ "${jobs}" -gt "${ADMINPARAM}" ]
534 then
535 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
536 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
537 else
538 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
539 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
540 fi
541 fi
542}
543
544# Cheap replacement for when debianutils (and thus mktemp)
545# does not exist on the users system
546# vapier@gentoo.org
547# 1034#
548# Takes just 1 parameter (the directory to create tmpfile in) 1035# example 1: doicon foobar.png fuqbar.svg suckbar.png
549mymktemp() { 1036# results in: insinto /usr/share/pixmaps
550 local topdir="$1" 1037# doins foobar.png fuqbar.svg suckbar.png
551
552 [ -z "${topdir}" ] && topdir=/tmp
553 if [ "`which mktemp 2>/dev/null`" ]
554 then
555 mktemp -p ${topdir}
556 else
557 local tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}"
558 touch ${tmp}
559 echo ${tmp}
560 fi
561}
562
563# Small wrapper for getent (Linux) and nidump (Mac OS X)
564# used in enewuser()/enewgroup()
565# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
566# 1038#
567# egetent(database, key) 1039# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
568egetent() { 1040# results in: insinto /usr/share/icons/hicolor/48x48/apps
569 if use macos || use ppc-macos ; then 1041# doins foobar.png fuqbar.png blobbar.png
570 case "$2" in 1042# @CODE
571 *[!0-9]*) # Non numeric 1043doicon() {
572 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 1044 _iconins ${FUNCNAME} "$@"
573 ;;
574 *) # Numeric
575 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
576 ;;
577 esac
578 else
579 getent $1 $2
580 fi
581} 1045}
582 1046
583# Simplify/standardize adding users to the system 1047# @FUNCTION: newicon
584# vapier@gentoo.org 1048# @USAGE: [options] <icon> <newname>
1049# @DESCRIPTION:
1050# Like doicon, install the specified icon as newname.
585# 1051#
586# enewuser(username, uid, shell, homedir, groups, extra options) 1052# @CODE
1053# example 1: newicon foobar.png NEWNAME.png
1054# results in: insinto /usr/share/pixmaps
1055# newins foobar.png NEWNAME.png
587# 1056#
588# Default values if you do not specify any: 1057# example 2: newicon -s 48 foobar.png NEWNAME.png
589# username: REQUIRED ! 1058# results in: insinto /usr/share/icons/hicolor/48x48/apps
590# uid: next available (see useradd(8)) 1059# newins foobar.png NEWNAME.png
591# note: pass -1 to get default behavior 1060# @CODE
592# shell: /bin/false 1061newicon() {
593# homedir: /dev/null 1062 _iconins ${FUNCNAME} "$@"
594# groups: none
595# extra: comment of 'added by portage for ${PN}'
596enewuser() {
597 # get the username
598 local euser="$1"; shift
599 if [ -z "${euser}" ]
600 then
601 eerror "No username specified !"
602 die "Cannot call enewuser without a username"
603 fi
604
605 # lets see if the username already exists
606 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ]
607 then
608 return 0
609 fi
610 einfo "Adding user '${euser}' to your system ..."
611
612 # options to pass to useradd
613 local opts=
614
615 # handle uid
616 local euid="$1"; shift
617 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
618 then
619 if [ "${euid}" -gt 0 ]
620 then
621 if [ ! -z "`egetent passwd ${euid}`" ]
622 then
623 euid="next"
624 fi
625 else
626 eerror "Userid given but is not greater than 0 !"
627 die "${euid} is not a valid UID"
628 fi
629 else
630 euid="next"
631 fi
632 if [ "${euid}" == "next" ]
633 then
634 local pwrange
635 if use macos || use ppc-macos ; then
636 pwrange="`jot 898 101`"
637 else
638 pwrange="`seq 101 999`"
639 fi
640 for euid in ${pwrange} ; do
641 [ -z "`egetent passwd ${euid}`" ] && break
642 done
643 fi
644 opts="${opts} -u ${euid}"
645 einfo " - Userid: ${euid}"
646
647 # handle shell
648 local eshell="$1"; shift
649 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ]
650 then
651 if [ ! -e "${eshell}" ]
652 then
653 eerror "A shell was specified but it does not exist !"
654 die "${eshell} does not exist"
655 fi
656 else
657 eshell="/bin/false"
658 fi
659 einfo " - Shell: ${eshell}"
660 opts="${opts} -s ${eshell}"
661
662 # handle homedir
663 local ehome="$1"; shift
664 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ]
665 then
666 ehome="/dev/null"
667 fi
668 einfo " - Home: ${ehome}"
669 opts="${opts} -d ${ehome}"
670
671 # handle groups
672 local egroups="$1"; shift
673 if [ ! -z "${egroups}" ]
674 then
675 local oldifs="${IFS}"
676 export IFS=","
677 for g in ${egroups}
678 do
679 if [ -z "`egetent group \"${g}\"`" ]
680 then
681 eerror "You must add group ${g} to the system first"
682 die "${g} is not a valid GID"
683 fi
684 done
685 export IFS="${oldifs}"
686 opts="${opts} -g ${egroups}"
687 else
688 egroups="(none)"
689 fi
690 einfo " - Groups: ${egroups}"
691
692 # handle extra and add the user
693 local eextra="$@"
694 local oldsandbox="${SANDBOX_ON}"
695 export SANDBOX_ON="0"
696 if use macos || use ppc-macos ;
697 then
698 ### Make the user
699 if [ -z "${eextra}" ]
700 then
701 dscl . create /users/${euser} uid ${euid}
702 dscl . create /users/${euser} shell ${eshell}
703 dscl . create /users/${euser} home ${ehome}
704 dscl . create /users/${euser} realname "added by portage for ${PN}"
705 ### Add the user to the groups specified
706 for g in ${egroups}
707 do
708 dscl . merge /groups/${g} users ${euser}
709 done
710 else
711 einfo "Extra options are not supported on macos yet"
712 einfo "Please report the ebuild along with the info below"
713 einfo "eextra: ${eextra}"
714 die "Required function missing"
715 fi
716 else
717 if [ -z "${eextra}" ]
718 then
719 useradd ${opts} ${euser} \
720 -c "added by portage for ${PN}" \
721 || die "enewuser failed"
722 else
723 einfo " - Extra: ${eextra}"
724 useradd ${opts} ${euser} ${eextra} \
725 || die "enewuser failed"
726 fi
727 fi
728 export SANDBOX_ON="${oldsandbox}"
729
730 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
731 then
732 einfo " - Creating ${ehome} in ${D}"
733 dodir ${ehome}
734 fowners ${euser} ${ehome}
735 fperms 755 ${ehome}
736 fi
737} 1063}
738 1064
739# Simplify/standardize adding groups to the system 1065# @FUNCTION: strip-linguas
740# vapier@gentoo.org 1066# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
741# 1067# @DESCRIPTION:
742# enewgroup(group, gid)
743#
744# Default values if you do not specify any:
745# groupname: REQUIRED !
746# gid: next available (see groupadd(8))
747# extra: none
748enewgroup() {
749 # get the group
750 local egroup="$1"; shift
751 if [ -z "${egroup}" ]
752 then
753 eerror "No group specified !"
754 die "Cannot call enewgroup without a group"
755 fi
756
757 # see if group already exists
758 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
759 then
760 return 0
761 fi
762 einfo "Adding group '${egroup}' to your system ..."
763
764 # options to pass to useradd
765 local opts=
766
767 # handle gid
768 local egid="$1"; shift
769 if [ ! -z "${egid}" ]
770 then
771 if [ "${egid}" -gt 0 ]
772 then
773 if [ -z "`egetent group ${egid}`" ]
774 then
775 if use macos || use ppc-macos ; then
776 opts="${opts} ${egid}"
777 else
778 opts="${opts} -g ${egid}"
779 fi
780 else
781 egid="next available; requested gid taken"
782 fi
783 else
784 eerror "Groupid given but is not greater than 0 !"
785 die "${egid} is not a valid GID"
786 fi
787 else
788 egid="next available"
789 fi
790 einfo " - Groupid: ${egid}"
791
792 # handle extra
793 local eextra="$@"
794 opts="${opts} ${eextra}"
795
796 # add the group
797 local oldsandbox="${SANDBOX_ON}"
798 export SANDBOX_ON="0"
799 if use macos || use ppc-macos ;
800 then
801 if [ ! -z "${eextra}" ];
802 then
803 einfo "Extra options are not supported on macos yet"
804 einfo "Please report the ebuild along with the info below"
805 einfo "eextra: ${eextra}"
806 die "Required function missing"
807 fi
808
809 # If we need the next available
810 case ${egid} in
811 *[!0-9]*) # Non numeric
812 for egid in `jot 898 101`; do
813 [ -z "`egetent group ${egid}`" ] && break
814 done
815 esac
816 dscl . create /groups/${egroup} gid ${egid}
817 dscl . create /groups/${egroup} passwd '*'
818 else
819 groupadd ${opts} ${egroup} || die "enewgroup failed"
820 fi
821 export SANDBOX_ON="${oldsandbox}"
822}
823
824# Simple script to replace 'dos2unix' binaries
825# vapier@gentoo.org
826#
827# edos2unix(file, <more files>...)
828edos2unix() {
829 for f in "$@"
830 do
831 cp "${f}" ${T}/edos2unix
832 sed 's/\r$//' ${T}/edos2unix > "${f}"
833 done
834}
835
836# Make a desktop file !
837# Great for making those icons in kde/gnome startmenu !
838# Amaze your friends ! Get the women ! Join today !
839# gnome2 /usr/share/applications
840# gnome1 /usr/share/gnome/apps/
841# KDE ${KDEDIR}/share/applnk /usr/share/applnk
842#
843# make_desktop_entry(<binary>, [name], [icon], [type], [path])
844#
845# binary: what binary does the app run with ?
846# name: the name that will show up in the menu
847# icon: give your little like a pretty little icon ...
848# this can be relative (to /usr/share/pixmaps) or
849# a full path to an icon
850# type: what kind of application is this ? for categories:
851# http://www.freedesktop.org/standards/menu-spec/
852# path: if your app needs to startup in a specific dir
853make_desktop_entry() {
854 [ -z "$1" ] && eerror "You must specify the executable" && return 1
855
856 local exec="${1}"
857 local name="${2:-${PN}}"
858 local icon="${3:-${PN}.png}"
859 local type="${4}"
860 local subdir="${6}"
861 local path="${5:-${GAMES_BINDIR}}"
862 if [ -z "${type}" ]
863 then
864 case ${CATEGORY} in
865 "app-emulation")
866 type=Emulator
867 subdir="Emulation"
868 ;;
869 "games-"*)
870 type=Game
871 subdir="Games"
872 ;;
873 "net-"*)
874 type=Network
875 subdir="${type}"
876 ;;
877 *)
878 type=
879 subdir=
880 ;;
881 esac
882 fi
883 local desktop="${T}/${exec}.desktop"
884
885echo "[Desktop Entry]
886Encoding=UTF-8
887Version=0.9.2
888Name=${name}
889Type=Application
890Comment=${DESCRIPTION}
891Exec=${exec}
892Path=${path}
893Icon=${icon}
894Categories=Application;${type};" > "${desktop}"
895
896 if [ -d "/usr/share/applications" ]
897 then
898 insinto /usr/share/applications
899 doins "${desktop}"
900 fi
901
902 #if [ -d "/usr/share/gnome/apps" ]
903 #then
904 # insinto /usr/share/gnome/apps/Games
905 # doins ${desktop}
906 #fi
907
908 #if [ ! -z "`ls /usr/kde/* 2>/dev/null`" ]
909 #then
910 # for ver in /usr/kde/*
911 # do
912 # insinto ${ver}/share/applnk/Games
913 # doins ${desktop}
914 # done
915 #fi
916
917 if [ -d "/usr/share/applnk" ]
918 then
919 insinto /usr/share/applnk/${subdir}
920 doins "${desktop}"
921 fi
922
923 return 0
924}
925
926# for internal use only (unpack_pdv and unpack_makeself)
927find_unpackable_file() {
928 local src="$1"
929 if [ -z "${src}" ]
930 then
931 src="${DISTDIR}/${A}"
932 else
933 if [ -e "${DISTDIR}/${src}" ]
934 then
935 src="${DISTDIR}/${src}"
936 elif [ -e "${PWD}/${src}" ]
937 then
938 src="${PWD}/${src}"
939 elif [ -e "${src}" ]
940 then
941 src="${src}"
942 fi
943 fi
944 [ ! -e "${src}" ] && die "Could not find requested archive ${src}"
945 echo "${src}"
946}
947
948# Unpack those pesky pdv generated files ...
949# They're self-unpacking programs with the binary package stuffed in
950# the middle of the archive. Valve seems to use it a lot ... too bad
951# it seems to like to segfault a lot :(. So lets take it apart ourselves.
952#
953# Usage: unpack_pdv [file to unpack] [size of off_t]
954# - you have to specify the off_t size ... i have no idea how to extract that
955# information out of the binary executable myself. basically you pass in
956# the size of the off_t type (in bytes) on the machine that built the pdv
957# archive. one way to determine this is by running the following commands:
958# strings <pdv archive> | grep lseek
959# strace -elseek <pdv archive>
960# basically look for the first lseek command (we do the strings/grep because
961# sometimes the function call is _llseek or something) and steal the 2nd
962# parameter. here is an example:
963# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
964# lseek
965# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
966# lseek(3, -4, SEEK_END) = 2981250
967# thus we would pass in the value of '4' as the second parameter.
968unpack_pdv() {
969 local src="`find_unpackable_file $1`"
970 local sizeoff_t="$2"
971
972 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
973
974 local shrtsrc="`basename ${src}`"
975 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
976 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
977 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
978
979 # grab metadata for debug reasons
980 local metafile="`mymktemp ${T}`"
981 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
982
983 # rip out the final file name from the metadata
984 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
985 datafile="`basename ${datafile}`"
986
987 # now lets uncompress/untar the file if need be
988 local tmpfile="`mymktemp ${T}`"
989 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
990
991 local iscompressed="`file -b ${tmpfile}`"
992 if [ "${iscompressed:0:8}" == "compress" ] ; then
993 iscompressed=1
994 mv ${tmpfile}{,.Z}
995 gunzip ${tmpfile}
996 else
997 iscompressed=0
998 fi
999 local istar="`file -b ${tmpfile}`"
1000 if [ "${istar:0:9}" == "POSIX tar" ] ; then
1001 istar=1
1002 else
1003 istar=0
1004 fi
1005
1006 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
1007 #dd if=${src} ibs=${metaskip} count=1 \
1008 # | dd ibs=${tailskip} skip=1 \
1009 # | gzip -dc \
1010 # > ${datafile}
1011 if [ ${iscompressed} -eq 1 ] ; then
1012 if [ ${istar} -eq 1 ] ; then
1013 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1014 | head -c $((${metaskip}-${tailskip})) \
1015 | tar -xzf -
1016 else
1017 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1018 | head -c $((${metaskip}-${tailskip})) \
1019 | gzip -dc \
1020 > ${datafile}
1021 fi
1022 else
1023 if [ ${istar} -eq 1 ] ; then
1024 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1025 | head -c $((${metaskip}-${tailskip})) \
1026 | tar --no-same-owner -xf -
1027 else
1028 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
1029 | head -c $((${metaskip}-${tailskip})) \
1030 > ${datafile}
1031 fi
1032 fi
1033 true
1034 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1035 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
1036}
1037
1038# Unpack those pesky makeself generated files ...
1039# They're shell scripts with the binary package tagged onto
1040# the end of the archive. Loki utilized the format as does
1041# many other game companies.
1042#
1043# Usage: unpack_makeself [file to unpack] [offset]
1044# - If the file is not specified then unpack will utilize ${A}.
1045# - If the offset is not specified then we will attempt to extract
1046# the proper offset from the script itself.
1047unpack_makeself() {
1048 local src="`find_unpackable_file $1`"
1049 local skip="$2"
1050
1051 local shrtsrc="`basename ${src}`"
1052 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1053 if [ -z "${skip}" ]
1054 then
1055 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
1056 local skip=0
1057 case ${ver} in
1058 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1059 skip=`grep -a ^skip= ${src} | cut -d= -f2`
1060 ;;
1061 2.0|2.0.1)
1062 skip=`grep -a ^$'\t'tail ${src} | awk '{print $2}' | cut -b2-`
1063 ;;
1064 2.1.1)
1065 skip=`grep -a ^offset= ${src} | awk '{print $2}' | cut -b2-`
1066 let skip="skip + 1"
1067 ;;
1068 2.1.2)
1069 skip=`grep -a ^offset= ${src} | awk '{print $3}' | head -n 1`
1070 let skip="skip + 1"
1071 ;;
1072 2.1.3)
1073 skip=`grep -a ^offset= ${src} | awk '{print $3}'`
1074 let skip="skip + 1"
1075 ;;
1076 *)
1077 eerror "I'm sorry, but I was unable to support the Makeself file."
1078 eerror "The version I detected was '${ver}'."
1079 eerror "Please file a bug about the file ${shrtsrc} at"
1080 eerror "http://bugs.gentoo.org/ so that support can be added."
1081 die "makeself version '${ver}' not supported"
1082 ;;
1083 esac
1084 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1085 fi
1086
1087 # lets grab the first few bytes of the file to figure out what kind of archive it is
1088 local tmpfile="`mymktemp ${T}`"
1089 tail -n +${skip} ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1090 local filetype="`file -b ${tmpfile}`"
1091 case ${filetype} in
1092 *tar\ archive)
1093 tail -n +${skip} ${src} | tar --no-same-owner -xf -
1094 ;;
1095 bzip2*)
1096 tail -n +${skip} ${src} | bzip2 -dc | tar --no-same-owner -xf -
1097 ;;
1098 gzip*)
1099 tail -n +${skip} ${src} | tar --no-same-owner -xzf -
1100 ;;
1101 compress*)
1102 tail -n +${skip} ${src} | gunzip | tar --no-same-owner -xf -
1103 ;;
1104 *)
1105 eerror "Unknown filetype \"${filetype}\" ?"
1106 false
1107 ;;
1108 esac
1109 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1110}
1111
1112# Display a license for user to accept.
1113#
1114# Usage: check_license [license]
1115# - If the file is not specified then ${LICENSE} is used.
1116check_license() {
1117 local lic=$1
1118 if [ -z "${lic}" ] ; then
1119 lic="${PORTDIR}/licenses/${LICENSE}"
1120 else
1121 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
1122 lic="${PORTDIR}/licenses/${src}"
1123 elif [ -e "${PWD}/${src}" ] ; then
1124 lic="${PWD}/${src}"
1125 elif [ -e "${src}" ] ; then
1126 lic="${src}"
1127 fi
1128 fi
1129 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
1130 local l="`basename ${lic}`"
1131
1132 # here is where we check for the licenses the user already
1133 # accepted ... if we don't find a match, we make the user accept
1134 local alic
1135 for alic in ${ACCEPT_LICENSE} ; do
1136 [ "${alic}" == "*" ] && return 0
1137 [ "${alic}" == "${l}" ] && return 0
1138 done
1139
1140 local licmsg="`mymktemp ${T}`"
1141 cat << EOF > ${licmsg}
1142**********************************************************
1143The following license outlines the terms of use of this
1144package. You MUST accept this license for installation to
1145continue. When you are done viewing, hit 'q'. If you
1146CTRL+C out of this, the install will not run!
1147**********************************************************
1148
1149EOF
1150 cat ${lic} >> ${licmsg}
1151 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1152 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1153 read alic
1154 case ${alic} in
1155 yes|Yes|y|Y)
1156 return 0
1157 ;;
1158 *)
1159 echo;echo;echo
1160 eerror "You MUST accept the license to continue! Exiting!"
1161 die "Failed to accept license"
1162 ;;
1163 esac
1164}
1165
1166# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1167# the whole 'non-interactive' policy, but damnit I want CD support !
1168#
1169# with these cdrom functions we handle all the user interaction and
1170# standardize everything. all you have to do is call cdrom_get_cds()
1171# and when the function returns, you can assume that the cd has been
1172# found at CDROM_ROOT.
1173#
1174# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1175# etc... if you want to give the cds better names, then just export
1176# the CDROM_NAME_X variables before calling cdrom_get_cds().
1177#
1178# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1179#
1180# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1181# - this will attempt to locate a cd based upon a file that is on
1182# the cd ... the more files you give this function, the more cds
1183# the cdrom functions will handle
1184cdrom_get_cds() {
1185 # first we figure out how many cds we're dealing with by
1186 # the # of files they gave us
1187 local cdcnt=0
1188 local f=
1189 for f in "$@" ; do
1190 cdcnt=$((cdcnt + 1))
1191 export CDROM_CHECK_${cdcnt}="$f"
1192 done
1193 export CDROM_TOTAL_CDS=${cdcnt}
1194 export CDROM_CURRENT_CD=1
1195
1196 # now we see if the user gave use CD_ROOT ...
1197 # if they did, let's just believe them that it's correct
1198 if [ ! -z "${CD_ROOT}" ] ; then
1199 export CDROM_ROOT="${CD_ROOT}"
1200 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1201 return
1202 fi
1203 # do the same for CD_ROOT_X
1204 if [ ! -z "${CD_ROOT_1}" ] ; then
1205 local var=
1206 cdcnt=0
1207 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1208 cdcnt=$((cdcnt + 1))
1209 var="CD_ROOT_${cdcnt}"
1210 if [ -z "${!var}" ] ; then
1211 eerror "You must either use just the CD_ROOT"
1212 eerror "or specify ALL the CD_ROOT_X variables."
1213 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1214 die "could not locate CD_ROOT_${cdcnt}"
1215 fi
1216 export CDROM_ROOTS_${cdcnt}="${!var}"
1217 done
1218 export CDROM_ROOT=${CDROM_ROOTS_1}
1219 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1220 return
1221 fi
1222
1223 if [ ${CDROM_TOTAL_CDS} -eq 1 ] ; then
1224 einfon "This ebuild will need the "
1225 if [ -z "${CDROM_NAME}" ] ; then
1226 echo "cdrom for ${PN}."
1227 else
1228 echo "${CDROM_NAME}."
1229 fi
1230 echo
1231 einfo "If you do not have the CD, but have the data files"
1232 einfo "mounted somewhere on your filesystem, just export"
1233 einfo "the variable CD_ROOT so that it points to the"
1234 einfo "directory containing the files."
1235 echo
1236 else
1237 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1238 cdcnt=0
1239 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1240 cdcnt=$((cdcnt + 1))
1241 var="CDROM_NAME_${cdcnt}"
1242 [ ! -z "${!var}" ] && einfo " CD ${cdcnt}: ${!var}"
1243 done
1244 echo
1245 einfo "If you do not have the CDs, but have the data files"
1246 einfo "mounted somewhere on your filesystem, just export"
1247 einfo "the following variables so they point to the right place:"
1248 einfon ""
1249 cdcnt=0
1250 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1251 cdcnt=$((cdcnt + 1))
1252 echo -n " CD_ROOT_${cdcnt}"
1253 done
1254 echo
1255 einfo "Or, if you have all the files in the same place, or"
1256 einfo "you only have one cdrom, you can export CD_ROOT"
1257 einfo "and that place will be used as the same data source"
1258 einfo "for all the CDs."
1259 echo
1260 fi
1261 export CDROM_CURRENT_CD=0
1262 cdrom_load_next_cd
1263}
1264
1265# this is only used when you need access to more than one cd.
1266# when you have finished using the first cd, just call this function.
1267# when it returns, CDROM_ROOT will be pointing to the second cd.
1268# remember, you can only go forward in the cd chain, you can't go back.
1269cdrom_load_next_cd() {
1270 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1271 local var=
1272
1273 if [ ! -z "${CD_ROOT}" ] ; then
1274 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1275 return
1276 fi
1277
1278 unset CDROM_ROOT
1279 var=CDROM_ROOTS_${CDROM_CURRENT_CD}
1280 if [ -z "${!var}" ] ; then
1281 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1282 cdrom_locate_file_on_cd ${!var}
1283 else
1284 export CDROM_ROOT="${!var}"
1285 fi
1286
1287 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1288}
1289
1290# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1291# functions. this should *never* be called from an ebuild.
1292# all it does is try to locate a give file on a cd ... if the cd isn't
1293# found, then a message asking for the user to insert the cdrom will be
1294# displayed and we'll hang out here until:
1295# (1) the file is found on a mounted cdrom
1296# (2) the user hits CTRL+C
1297cdrom_locate_file_on_cd() {
1298 while [ -z "${CDROM_ROOT}" ] ; do
1299 local dir="$(dirname ${@})"
1300 local file="$(basename ${@})"
1301 local mline=""
1302 local showedmsg=0
1303
1304 for mline in `mount | egrep -e '(iso|cdrom)' | awk '{print $3}'` ; do
1305 [ -d "${mline}/${dir}" ] || continue
1306 [ ! -z "$(find ${mline}/${dir} -iname ${file} -maxdepth 1)" ] \
1307 && export CDROM_ROOT=${mline}
1308 done
1309
1310 if [ -z "${CDROM_ROOT}" ] ; then
1311 echo
1312 if [ ${showedmsg} -eq 0 ] ; then
1313 if [ ${CDROM_TOTAL_CDS} -eq 1 ] ; then
1314 if [ -z "${CDROM_NAME}" ] ; then
1315 einfo "Please insert the cdrom for ${PN} now !"
1316 else
1317 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1318 fi
1319 else
1320 if [ -z "${CDROM_NAME_1}" ] ; then
1321 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1322 else
1323 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1324 einfo "Please insert+mount the ${!var} cdrom now !"
1325 fi
1326 fi
1327 showedmsg=1
1328 fi
1329 einfo "Press return to scan for the cd again"
1330 einfo "or hit CTRL+C to abort the emerge."
1331 read
1332 fi
1333 done
1334}
1335
1336# Make sure that LINGUAS only contains languages that 1068# Make sure that LINGUAS only contains languages that
1337# a package can support 1069# a package can support. The first form allows you to
1338# 1070# specify a list of LINGUAS. The -i builds a list of po
1339# usage: strip-linguas <allow LINGUAS> 1071# files found in all the directories and uses the
1340# strip-linguas -i <directories of .po files> 1072# intersection of the lists. The -u builds a list of po
1341# strip-linguas -u <directories of .po files> 1073# files found in all the directories and uses the union
1342# 1074# of the lists.
1343# The first form allows you to specify a list of LINGUAS.
1344# The -i builds a list of po files found in all the
1345# directories and uses the intersection of the lists.
1346# The -u builds a list of po files found in all the
1347# directories and uses the union of the lists.
1348strip-linguas() { 1075strip-linguas() {
1349 local ls newls 1076 local ls newls nols
1350 if [ "$1" == "-i" ] || [ "$1" == "-u" ] ; then 1077 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1351 local op="$1"; shift 1078 local op=$1; shift
1352 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1079 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1353 local d f 1080 local d f
1354 for d in "$@" ; do 1081 for d in "$@" ; do
1355 if [ "${op}" == "-u" ] ; then 1082 if [[ ${op} == "-u" ]] ; then
1356 newls="${ls}" 1083 newls=${ls}
1357 else 1084 else
1358 newls="" 1085 newls=""
1359 fi 1086 fi
1360 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1087 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1361 if [ "${op}" == "-i" ] ; then 1088 if [[ ${op} == "-i" ]] ; then
1362 [ "${ls/ ${f} /}" != "${ls}" ] && newls="${newls} ${f}" 1089 has ${f} ${ls} && newls="${newls} ${f}"
1363 else 1090 else
1364 [ "${ls/ ${f} /}" == "${ls}" ] && newls="${newls} ${f}" 1091 has ${f} ${ls} || newls="${newls} ${f}"
1365 fi 1092 fi
1366 done 1093 done
1367 ls="${newls}" 1094 ls=${newls}
1368 done 1095 done
1369 ls="${ls//.po}"
1370 else 1096 else
1371 ls="$@" 1097 ls="$@"
1372 fi 1098 fi
1373 1099
1374 ls=" ${ls} " 1100 nols=""
1375 newls="" 1101 newls=""
1376 for f in ${LINGUAS} ; do 1102 for f in ${LINGUAS} ; do
1377 if [ "${ls/ ${f} /}" != "${ls}" ] ; then 1103 if has ${f} ${ls} ; then
1378 nl="${newls} ${f}" 1104 newls="${newls} ${f}"
1379 else 1105 else
1380 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1106 nols="${nols} ${f}"
1381 fi 1107 fi
1382 done 1108 done
1109 [[ -n ${nols} ]] \
1110 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1111 export LINGUAS=${newls:1}
1112}
1113
1114# @FUNCTION: preserve_old_lib
1115# @USAGE: <libs to preserve> [more libs]
1116# @DESCRIPTION:
1117# These functions are useful when a lib in your package changes ABI SONAME.
1118# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1119# would break packages that link against it. Most people get around this
1120# by using the portage SLOT mechanism, but that is not always a relevant
1121# solution, so instead you can call this from pkg_preinst. See also the
1122# preserve_old_lib_notify function.
1123preserve_old_lib() {
1124 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1125 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1126 die "Invalid preserve_old_lib() usage"
1127 fi
1128 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1129
1130 # let portage worry about it
1131 has preserve-libs ${FEATURES} && return 0
1132
1133 local lib dir
1134 for lib in "$@" ; do
1135 [[ -e ${ROOT}/${lib} ]] || continue
1136 dir=${lib%/*}
1137 dodir ${dir} || die "dodir ${dir} failed"
1138 cp "${ROOT}"/${lib} "${D}"/${lib} || die "cp ${lib} failed"
1139 touch "${D}"/${lib}
1140 done
1141}
1142
1143# @FUNCTION: preserve_old_lib_notify
1144# @USAGE: <libs to notify> [more libs]
1145# @DESCRIPTION:
1146# Spit helpful messages about the libraries preserved by preserve_old_lib.
1147preserve_old_lib_notify() {
1148 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1149 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1150 die "Invalid preserve_old_lib_notify() usage"
1151 fi
1152
1153 # let portage worry about it
1154 has preserve-libs ${FEATURES} && return 0
1155
1156 local lib notice=0
1157 for lib in "$@" ; do
1158 [[ -e ${ROOT}/${lib} ]] || continue
1159 if [[ ${notice} -eq 0 ]] ; then
1160 notice=1
1161 ewarn "Old versions of installed libraries were detected on your system."
1162 ewarn "In order to avoid breaking packages that depend on these old libs,"
1163 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1164 ewarn "in order to remove these old dependencies. If you do not have this"
1165 ewarn "helper program, simply emerge the 'gentoolkit' package."
1166 ewarn
1167 fi
1168 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1169 done
1170}
1171
1172# @FUNCTION: built_with_use
1173# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1174# @DESCRIPTION:
1175#
1176# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1177#
1178# A temporary hack until portage properly supports DEPENDing on USE
1179# flags being enabled in packages. This will check to see if the specified
1180# DEPEND atom was built with the specified list of USE flags. The
1181# --missing option controls the behavior if called on a package that does
1182# not actually support the defined USE flags (aka listed in IUSE).
1183# The default is to abort (call die). The -a and -o flags control
1184# the requirements of the USE flags. They correspond to "and" and "or"
1185# logic. So the -a flag means all listed USE flags must be enabled
1186# while the -o flag means at least one of the listed IUSE flags must be
1187# enabled. The --hidden option is really for internal use only as it
1188# means the USE flag we're checking is hidden expanded, so it won't be found
1189# in IUSE like normal USE flags.
1190#
1191# Remember that this function isn't terribly intelligent so order of optional
1192# flags matter.
1193built_with_use() {
1194 local hidden="no"
1195 if [[ $1 == "--hidden" ]] ; then
1196 hidden="yes"
1197 shift
1198 fi
1199
1200 local missing_action="die"
1201 if [[ $1 == "--missing" ]] ; then
1202 missing_action=$2
1203 shift ; shift
1204 case ${missing_action} in
1205 true|false|die) ;;
1206 *) die "unknown action '${missing_action}'";;
1207 esac
1208 fi
1209
1210 local opt=$1
1211 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1212
1213 local PKG=$(best_version $1)
1214 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1215 shift
1216
1217 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1218 local IUSEFILE=${ROOT}/var/db/pkg/${PKG}/IUSE
1219
1220 # if the IUSE file doesn't exist, the read will error out, we need to handle
1221 # this gracefully
1222 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1223 case ${missing_action} in
1224 true) return 0;;
1225 false) return 1;;
1226 die) die "Unable to determine what USE flags $PKG was built with";;
1227 esac
1228 fi
1229
1230 if [[ ${hidden} == "no" ]] ; then
1231 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1232 # Don't check USE_EXPAND #147237
1233 local expand
1234 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1235 if [[ $1 == ${expand}_* ]] ; then
1236 expand=""
1237 break
1238 fi
1239 done
1240 if [[ -n ${expand} ]] ; then
1241 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1242 case ${missing_action} in
1243 true) return 0;;
1244 false) return 1;;
1245 die) die "$PKG does not actually support the $1 USE flag!";;
1246 esac
1247 fi
1248 fi
1249 fi
1250
1251 local USE_BUILT=$(<${USEFILE})
1252 while [[ $# -gt 0 ]] ; do
1253 if [[ ${opt} = "-o" ]] ; then
1254 has $1 ${USE_BUILT} && return 0
1255 else
1256 has $1 ${USE_BUILT} || return 1
1257 fi
1258 shift
1259 done
1260 [[ ${opt} = "-a" ]]
1261}
1262
1263# @FUNCTION: epunt_cxx
1264# @USAGE: [dir to scan]
1265# @DESCRIPTION:
1266# Many configure scripts wrongly bail when a C++ compiler could not be
1267# detected. If dir is not specified, then it defaults to ${S}.
1268#
1269# http://bugs.gentoo.org/73450
1270epunt_cxx() {
1271 local dir=$1
1272 [[ -z ${dir} ]] && dir=${S}
1273 ebegin "Removing useless C++ checks"
1274 local f
1275 find "${dir}" -name configure | while read f ; do
1276 patch --no-backup-if-mismatch -p0 "${f}" "${PORTDIR}/eclass/ELT-patches/nocxx/nocxx.patch" > /dev/null
1277 done
1278 eend 0
1279}
1280
1281# @FUNCTION: make_wrapper
1282# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1283# @DESCRIPTION:
1284# Create a shell wrapper script named wrapper in installpath
1285# (defaults to the bindir) to execute target (default of wrapper) by
1286# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1287# libpaths followed by optionally changing directory to chdir.
1288make_wrapper() {
1289 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1290 local tmpwrapper=$(emktemp)
1291 # We don't want to quote ${bin} so that people can pass complex
1292 # things as $bin ... "./someprog --args"
1293 cat << EOF > "${tmpwrapper}"
1294#!/bin/sh
1295cd "${chdir:-.}"
1383 if [ -z "${newls}" ] ; then 1296if [ -n "${libdir}" ] ; then
1384 unset LINGUAS 1297 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1298 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1385 else 1299 else
1386 export LINGUAS="${newls}" 1300 export LD_LIBRARY_PATH="${libdir}"
1301 fi
1302fi
1303exec ${bin} "\$@"
1304EOF
1305 chmod go+rx "${tmpwrapper}"
1306 if [[ -n ${path} ]] ; then
1307 (
1308 exeinto "${path}"
1309 newexe "${tmpwrapper}" "${wrapper}"
1310 ) || die
1311 else
1312 newbin "${tmpwrapper}" "${wrapper}" || die
1313 fi
1314}
1315
1316# @FUNCTION: path_exists
1317# @USAGE: [-a|-o] <paths>
1318# @DESCRIPTION:
1319# Check if the specified paths exist. Works for all types of paths
1320# (files/dirs/etc...). The -a and -o flags control the requirements
1321# of the paths. They correspond to "and" and "or" logic. So the -a
1322# flag means all the paths must exist while the -o flag means at least
1323# one of the paths must exist. The default behavior is "and". If no
1324# paths are specified, then the return value is "false".
1325path_exists() {
1326 local opt=$1
1327 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1328
1329 # no paths -> return false
1330 # same behavior as: [[ -e "" ]]
1331 [[ $# -eq 0 ]] && return 1
1332
1333 local p r=0
1334 for p in "$@" ; do
1335 [[ -e ${p} ]]
1336 : $(( r += $? ))
1337 done
1338
1339 case ${opt} in
1340 -a) return $(( r != 0 )) ;;
1341 -o) return $(( r == $# )) ;;
1342 esac
1343}
1344
1345# @FUNCTION: in_iuse
1346# @USAGE: <flag>
1347# @DESCRIPTION:
1348# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1349# as necessary.
1350#
1351# Note that this function should not be used in the global scope.
1352in_iuse() {
1353 debug-print-function ${FUNCNAME} "${@}"
1354 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1355
1356 local flag=${1}
1357 local liuse=( ${IUSE} )
1358
1359 has "${flag}" "${liuse[@]#[+-]}"
1360}
1361
1362# @FUNCTION: use_if_iuse
1363# @USAGE: <flag>
1364# @DESCRIPTION:
1365# Return true if the given flag is in USE and IUSE.
1366#
1367# Note that this function should not be used in the global scope.
1368use_if_iuse() {
1369 in_iuse $1 || return 1
1370 use $1
1371}
1372
1373# @FUNCTION: usex
1374# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1375# @DESCRIPTION:
1376# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1377# otherwise echo [false output][false suffix] (defaults to "no").
1378usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1379
1380# @FUNCTION: prune_libtool_files
1381# @USAGE: [--all]
1382# @DESCRIPTION:
1383# Locate unnecessary libtool files (.la) and libtool static archives
1384# (.a) and remove them from installation image.
1385#
1386# By default, .la files are removed whenever the static linkage can
1387# either be performed using pkg-config or doesn't introduce additional
1388# flags.
1389#
1390# If '--all' argument is passed, all .la files are removed. This is
1391# usually useful when the package installs plugins and does not use .la
1392# files for loading them.
1393#
1394# The .a files are only removed whenever corresponding .la files state
1395# that they should not be linked to, i.e. whenever these files
1396# correspond to plugins.
1397#
1398# Note: if your package installs any .pc files, this function implicitly
1399# calls pkg-config. You should add it to your DEPEND in that case.
1400prune_libtool_files() {
1401 debug-print-function ${FUNCNAME} "$@"
1402
1403 local removing_all opt
1404 for opt; do
1405 case "${opt}" in
1406 --all)
1407 removing_all=1
1408 ;;
1409 *)
1410 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1411 esac
1412 done
1413
1414 # Create a list of all .pc-covered libs.
1415 local pc_libs=()
1416 if [[ ! ${removing_all} ]]; then
1417 local f
1418 local tf=${T}/prune-lt-files.pc
1419 local pkgconf=$(tc-getPKG_CONFIG)
1420
1421 while IFS= read -r -d '' f; do # for all .pc files
1422 local arg
1423
1424 sed -e '/^Requires:/d' "${f}" > "${tf}"
1425 for arg in $("${pkgconf}" --libs "${tf}"); do
1426 [[ ${arg} == -l* ]] && pc_libs+=( lib${arg#-l}.la )
1427 done
1428 done < <(find "${D}" -type f -name '*.pc' -print0)
1429
1430 rm -f "${tf}"
1431 fi
1432
1433 local f
1434 while IFS= read -r -d '' f; do # for all .la files
1435 local archivefile=${f/%.la/.a}
1436
1437 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1438
1439 # Remove static libs we're not supposed to link against.
1440 if grep -q '^shouldnotlink=yes$' "${f}"; then
1441 if [[ -f ${archivefile} ]]; then
1442 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1443 rm -f "${archivefile}"
1444 fi
1445
1446 # The .la file may be used by a module loader, so avoid removing it
1447 # unless explicitly requested.
1448 [[ ${removing_all} ]] || continue
1387 fi 1449 fi
1450
1451 # Remove .la files when:
1452 # - user explicitly wants us to remove all .la files,
1453 # - respective static archive doesn't exist,
1454 # - they are covered by a .pc file already,
1455 # - they don't provide any new information (no libs & no flags).
1456 local reason
1457 if [[ ${removing_all} ]]; then
1458 reason='requested'
1459 elif [[ ! -f ${archivefile} ]]; then
1460 reason='no static archive'
1461 elif has "${f##*/}" "${pc_libs[@]}"; then
1462 reason='covered by .pc'
1463 elif [[ ! $(sed -nre \
1464 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1465 "${f}") ]]; then
1466 reason='no libs & flags'
1467 fi
1468
1469 if [[ ${reason} ]]; then
1470 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1471 rm -f "${f}"
1472 fi
1473 done < <(find "${D}" -type f -name '*.la' -print0)
1388} 1474}
1475
1476check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1477
1478fi

Legend:
Removed from v.1.104  
changed lines
  Added in v.1.401

  ViewVC Help
Powered by ViewVC 1.1.20